#property copyright "Copyright(C)2010, ForexTradingLaboratory"
#property link      "http://www.ftlabo.com/index.php"

#include <stdlib.mqh>
#include <stderror.mqh> 

extern string Program = "TOPGUN FX";
extern string Rev = "201";
extern double Lots = 0.01;
extern int iBandsPeriod = 16;
extern int HourStart = 22;
extern int HourEnd = 8;
extern bool UseAutoLot = FALSE;
extern double MaxLots = 10;
extern double MinLots = 0.01;
extern double MaximumRisk = 3.0;
extern int Slippage = 3;
extern bool Aggressive = TRUE;
extern int Nanpin1 = 8;
extern int Nanpin2 = 50;
extern int FTLOrderWaitingTime = 10;
extern double TP1 = 10.0;
extern double TP2 = 15.0;
extern double TP3 = 15.0;
extern int BuyLossPoint = 240;
extern int SellLossPoint = 240;
//extern int LowToHigh = 400;
extern int MAGIC1 = 122331;
extern int MAGIC2 = 122332;
extern int MAGIC3 = 122333;
extern string OrdComment = "TOPGUN FX";

string OrderReliableVersion = "V0_2_3"; 

extern int retry_attempts 		= 10; 
extern double sleep_time 		= 4.0;
extern double sleep_maximum 	= 25.0;  // in seconds

string OrderReliable_Fname = "OrderReliable fname unset";
static int _OR_err = 0;



int gi_unused_248;
int gi_252 = 1;
int gi_256 = 1;
int gia_260[6] = {16711680, 255, 16711680, 255, 16711680, 255};

int init() {
   gi_unused_248 = 1;
   if (IsTesting() == TRUE) gi_unused_248 = 1;
   string ls_0 = "EA Name:" + Program 
   + "\n";
   string ls_8 = "Rev:" + Rev 
   + "\n";
   Comment("Local Time:" + TimeToStr(TimeLocal(), TIME_DATE) + " " + TimeToStr(TimeLocal(), TIME_SECONDS), " System Run", 
   "\n", "--Copyright----------------------------------------------------------------------\n", ls_0, ls_8, "--------------------------------------------------------------------------------------");
   if (Aggressive) {
      gi_252 = Nanpin1;
      gi_256 = Nanpin2;
   }
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   HideTestIndicators(TRUE);
   if (UseAutoLot) Lots = LotsOptimized();
   double ld_0 = 0;
   double ld_8 = NormalizeDouble(Ask, Digits);
   double ld_16 = NormalizeDouble(Bid, Digits);
   double maxlot_24 = MarketInfo(Symbol(), MODE_MAXLOT);
   double ibands_32 = iBands(NULL, 0, iBandsPeriod, 2, 0, PRICE_MEDIAN, MODE_UPPER, 3);
   double ibands_40 = iBands(NULL, 0, iBandsPeriod, 2, 0, PRICE_MEDIAN, MODE_LOWER, 3);
   double ld_48 = MathAbs(ibands_32 - ibands_40);
   if (FTLCurrentOrders(0, MAGIC1) > 0.0 && FTLCurrentOrders(0, MAGIC2) == 0.0) {
      if (ld_16 > FTLOrderOpenPrice(MAGIC1) + TP1 * Point) {
         while (ld_16 < FTLOrderClose(Slippage, MAGIC1)) {
         }
      }
   } else {
      if (FTLCurrentOrders(1, MAGIC1) < 0.0 && FTLCurrentOrders(1, MAGIC2) == 0.0) {
         if (ld_8 < FTLOrderOpenPrice(MAGIC1) - TP1 * Point) {
            while (ld_8 < FTLOrderClose(Slippage, MAGIC1)) {
            }
         }
      }
   }
   if (FTLCurrentOrders(0, MAGIC2) > 0.0 && FTLCurrentOrders(0, MAGIC3) == 0.0) {
      if (ld_16 > FTLOrderOpenPrice(MAGIC2) + TP2 * Point) {
         while (ld_16 < FTLOrderClose(Slippage, MAGIC2)) {
         }
         while (ld_16 < FTLOrderClose(Slippage, MAGIC1)) {
         }
      }
   } else {
      if (FTLCurrentOrders(1, MAGIC2) < 0.0 && FTLCurrentOrders(1, MAGIC3) == 0.0) {
         if (ld_8 < FTLOrderOpenPrice(MAGIC2) - TP2 * Point) {
            while (ld_8 < FTLOrderClose(Slippage, MAGIC2)) {
            }
            while (ld_8 < FTLOrderClose(Slippage, MAGIC1)) {
            }
         }
      }
   }
   if (FTLCurrentOrders(0, MAGIC3) > 0.0) {
      if (ld_16 > FTLOrderOpenPrice(MAGIC3) + TP3 * Point || ld_16 < FTLOrderOpenPrice(MAGIC3) - BuyLossPoint * Point) {
         while (ld_16 < FTLOrderClose(Slippage, MAGIC3)) {
         }
         while (ld_16 < FTLOrderClose(Slippage, MAGIC2)) {
         }
         while (ld_16 < FTLOrderClose(Slippage, MAGIC1)) {
         }
      }
   } else {
      if (FTLCurrentOrders(1, MAGIC3) < 0.0) {
         if (ld_8 < FTLOrderOpenPrice(MAGIC3) - TP3 * Point || ld_8 > FTLOrderOpenPrice(MAGIC3) + SellLossPoint * Point) {
            while (ld_8 < FTLOrderClose(Slippage, MAGIC3)) {
            }
            while (ld_8 < FTLOrderClose(Slippage, MAGIC2)) {
            }
            while (ld_8 < FTLOrderClose(Slippage, MAGIC1)) {
            }
         }
      }
   }
//   if (TimeHour(TimeCurrent()) >= 22 || TimeHour(TimeCurrent()) <= 8) {
   if (TimeHour(TimeCurrent()) >= HourStart || TimeHour(TimeCurrent()) <= HourEnd) {
      if (FTLCurrentOrders(6, MAGIC1) == 0.0) {
         if (ld_48 >= 15.0 * Point) {
            for (ld_0 = Lots; ld_0 > maxlot_24; ld_0 -= maxlot_24) {
               if (ld_8 < ibands_40) FTLOrderSendSL(0, maxlot_24, ld_8, Slippage, 0, 0, OrdComment, MAGIC1);
               if (ld_16 > ibands_32) FTLOrderSendSL(1, maxlot_24, ld_16, Slippage, 0, 0, OrdComment, MAGIC1);
            }
            if (ld_8 < ibands_40) FTLOrderSendSL(0, ld_0, ld_8, Slippage, 0, 0, OrdComment, MAGIC1);
            if (ld_16 > ibands_32) FTLOrderSendSL(1, ld_0, ld_16, Slippage, 0, 0, OrdComment, MAGIC1);
         }
      }
      if (FTLCurrentOrders(0, MAGIC2) == 0.0 && FTLCurrentOrders(0, MAGIC1) > 0.0) {
         if (ld_8 < FTLOrderOpenPrice(MAGIC1) - 50.0 * Point) {
            for (ld_0 = Lots * gi_252; ld_0 > maxlot_24; ld_0 -= maxlot_24) FTLOrderSendSL(0, maxlot_24, ld_8, Slippage, 0, 0, OrdComment, MAGIC2);
            FTLOrderSendSL(0, ld_0, ld_8, Slippage, 0, 0, OrdComment, MAGIC2);
         }
      } else {
         if (FTLCurrentOrders(1, MAGIC2) == 0.0 && FTLCurrentOrders(1, MAGIC1) < 0.0) {
            if (ld_16 > FTLOrderOpenPrice(MAGIC1) + 50.0 * Point) {
               for (ld_0 = Lots * gi_252; ld_0 > maxlot_24; ld_0 -= maxlot_24) FTLOrderSendSL(1, maxlot_24, ld_16, Slippage, 0, 0, OrdComment, MAGIC2);
               FTLOrderSendSL(1, ld_0, ld_16, Slippage, 0, 0, OrdComment, MAGIC2);
            }
         }
      }
      if (FTLCurrentOrders(0, MAGIC3) == 0.0 && FTLCurrentOrders(0, MAGIC2) > 0.0) {
         if (ld_8 < FTLOrderOpenPrice(MAGIC2) - 50.0 * Point) {
            for (ld_0 = Lots * gi_256; ld_0 > maxlot_24; ld_0 -= maxlot_24) FTLOrderSendSL(0, maxlot_24, ld_8, Slippage, 0, 0, OrdComment, MAGIC3);
            FTLOrderSendSL(0, ld_0, ld_8, Slippage, 0, 0, OrdComment, MAGIC3);
         }
      } else {
         if (FTLCurrentOrders(1, MAGIC3) == 0.0 && FTLCurrentOrders(1, MAGIC2) < 0.0) {
            if (ld_16 > FTLOrderOpenPrice(MAGIC2) + 50.0 * Point) {
               for (ld_0 = Lots * gi_256; ld_0 > maxlot_24; ld_0 -= maxlot_24) FTLOrderSendSL(1, maxlot_24, ld_16, Slippage, 0, 0, OrdComment, MAGIC3);
               FTLOrderSendSL(1, ld_0, ld_16, Slippage, 0, 0, OrdComment, MAGIC3);
            }
         }
      }
   }
   return (0);
}

double LotsOptimized() {
   double ld_ret_0 = MaxLots;
   int l_hist_total_8 = OrdersHistoryTotal();
   int l_count_12 = 0;
   ld_ret_0 = NormalizeDouble(AccountFreeMargin() * MaximumRisk / 1250000.0, 1);
   if (ld_ret_0 < 0.1) ld_ret_0 = 0.1;
   if (MinLots < 0.1 || ld_ret_0 < 0.1) {
      ld_ret_0 = NormalizeDouble(AccountFreeMargin() * MaximumRisk / 125000.0, 2);
      if (ld_ret_0 < 0.01) ld_ret_0 = 0.01;
   }
    {
      for (int l_pos_16 = l_hist_total_8 - 1; l_pos_16 >= 0; l_pos_16--) {
         if (OrderSelect(l_pos_16, SELECT_BY_POS, MODE_HISTORY) == FALSE) {
            Print("Error in history!");
            break;
         }
         if (OrderSymbol() != Symbol() || OrderType() > OP_SELL) continue;
         if (OrderProfit() > 0.0) break;
         if (OrderProfit() < 0.0) l_count_12++;
      }
      if (l_count_12 > 1) ld_ret_0 = NormalizeDouble(ld_ret_0 - ld_ret_0 * l_count_12 , 1);
   }
   if (ld_ret_0 < MinLots) ld_ret_0 = MinLots;
   if (ld_ret_0 > MaxLots) ld_ret_0 = MaxLots;
   if (!UseAutoLot) ld_ret_0 = MaxLots;
   return (ld_ret_0);
}

double FTLOrderOpenPrice(int a_magic_0) {
   for (int pos_4 = 0; pos_4 < OrdersTotal(); pos_4++) {
      if (OrderSelect(pos_4, SELECT_BY_POS) == FALSE) break;
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != a_magic_0) continue;
      if (OrderType() != OP_BUY && OrderType() != OP_SELL) continue;
      return (OrderOpenPrice());
   }
   return (0);
}

double FTLCurrentOrders(int ai_0, int a_magic_4) {
   double ld_ret_8 = 0.0;
   for (int pos_16 = 0; pos_16 < OrdersTotal(); pos_16++) {
      if (OrderSelect(pos_16, SELECT_BY_POS) == FALSE) break;
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != a_magic_4) continue;
      switch (ai_0) {
      case 0:
         if (OrderType() == OP_BUY) ld_ret_8 += OrderLots();
         break;
      case 1:
         if (OrderType() == OP_SELL) ld_ret_8 -= OrderLots();
         break;
      case 2:
         if (OrderType() == OP_BUYLIMIT) ld_ret_8 += OrderLots();
         break;
      case 3:
         if (OrderType() == OP_SELLLIMIT) ld_ret_8 -= OrderLots();
         break;
      case 4:
         if (OrderType() == OP_BUYSTOP) ld_ret_8 += OrderLots();
         break;
      case 5:
         if (OrderType() == OP_SELLSTOP) ld_ret_8 -= OrderLots();
         break;
      case 6:
         if (OrderType() == OP_BUY) ld_ret_8 += OrderLots();
         if (OrderType() == OP_SELL) ld_ret_8 -= OrderLots();
         break;
      case 7:
         if (OrderType() == OP_BUYLIMIT) ld_ret_8 += OrderLots();
         if (OrderType() == OP_SELLLIMIT) ld_ret_8 -= OrderLots();
         break;
      case 8:
         if (OrderType() == OP_BUYSTOP) ld_ret_8 += OrderLots();
         if (OrderType() == OP_SELLSTOP) ld_ret_8 -= OrderLots();
         break;
      case 9:
         if (OrderType() == OP_BUYLIMIT || OrderType() == OP_BUYSTOP) ld_ret_8 += OrderLots();
         if (OrderType() == OP_SELLLIMIT || OrderType() == OP_SELLSTOP) ld_ret_8 -= OrderLots();
         break;
      case 10:
         if (OrderType() == OP_BUY || OrderType() == OP_BUYLIMIT || OrderType() == OP_BUYSTOP) ld_ret_8 += OrderLots();
         break;
      case 11:
         if (OrderType() == OP_SELL || OrderType() == OP_SELLLIMIT || OrderType() == OP_SELLSTOP) ld_ret_8 -= OrderLots();
         break;
      case 12:
         if (OrderType() == OP_BUY || OrderType() == OP_BUYLIMIT || OrderType() == OP_BUYSTOP) ld_ret_8 += OrderLots();
         if (OrderType() == OP_SELL || OrderType() == OP_SELLLIMIT || OrderType() == OP_SELLSTOP) ld_ret_8 -= OrderLots();
         break;
      default:
         Print("[CurrentOrdersError] : Illegal order type(" + ai_0 + ")");
      }
   }
   return (ld_ret_8);
}

int FTLOrderSend(int a_cmd_0, double a_lots_4, double a_price_12, int a_slippage_20, double a_price_24, double a_price_32, string a_comment_40, int a_magic_48) {
   int error_52;
   a_price_12 = NormalizeDouble(a_price_12, Digits);
   a_price_24 = NormalizeDouble(a_price_24, Digits);
   a_price_32 = NormalizeDouble(a_price_32, Digits);
   int li_56 = GetTickCount();
   while (true) {
      if (GetTickCount() - li_56 > 1000 * FTLOrderWaitingTime) {
         Alert("OrderSend timeout. Check the experts log.");
         return (0);
      }
      if (IsTradeAllowed() == TRUE) {
         RefreshRates();
         if (OrderSendReliable(Symbol(), a_cmd_0, a_lots_4, a_price_12, a_slippage_20, a_price_24, a_price_32, a_comment_40, a_magic_48, 0, gia_260[a_cmd_0]) != -1) return (1);
         error_52 = GetLastError();
         Print("[OrderSendError] : ", error_52, " ", ErrorDescription(error_52));
         if (error_52 != 129/* INVALID_PRICE */) {
            if (error_52 != 130/* INVALID_STOPS */) {
            }
         }
      }
      Sleep(100);
   }
   return (0);
}

int FTLOrderClose(int a_slippage_0, int a_magic_4) {
   int cmd_8;
   int error_12;
   int ticket_16 = 0;
   for (int pos_20 = 0; pos_20 < OrdersTotal(); pos_20++) {
      if (OrderSelect(pos_20, SELECT_BY_POS) == FALSE) break;
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != a_magic_4) continue;
      cmd_8 = OrderType();
      if (cmd_8 == OP_BUY || cmd_8 == OP_SELL) {
         ticket_16 = OrderTicket();
         break;
      }
   }
   if (ticket_16 == 0) return (0);
   int li_24 = GetTickCount();
   while (true) {
      if (GetTickCount() - li_24 > 1000 * FTLOrderWaitingTime) {
         Alert("OrderClose timeout. Check the experts log.");
         return (0);
      }
      if (IsTradeAllowed() == TRUE) {
         RefreshRates();
         if (OrderCloseReliable(ticket_16, OrderLots(), NormalizeDouble(OrderClosePrice(), Digits), a_slippage_0, gia_260[cmd_8]) == 1) return (1);
         error_12 = GetLastError();
         Print("[OrderCloseError] : ", error_12, " ", ErrorDescription(error_12));
         if (error_12 != 129/* INVALID_PRICE */) {
         }
      }
      Sleep(100);
   }
   return (0);
}

void FTLOrderSendSL(int ai_0, double ad_4, double ad_12, int ai_20, int ai_24, int ai_28, string as_32, int ai_40) {
   int li_44 = 1;
   if (Digits == 3 || Digits == 5) li_44 = 10;
   ai_20 *= li_44;
   if (ai_0 == 1 || ai_0 == 3 || ai_0 == 5) li_44 = -1 * li_44;
   double ld_48 = 0;
   double ld_56 = 0;
   if (ai_24 > 0) ld_48 = ad_12 - ai_24 * Point * li_44;
   if (ai_28 > 0) ld_56 = ad_12 + ai_28 * Point * li_44;
   FTLOrderSend(ai_0, ad_4, ad_12, ai_20, ld_48, ld_56, as_32, ai_40);
}

//=============================================================================
//							 OrderSendReliable()
//
//	This is intended to be a drop-in replacement for OrderSend() which, 
//	one hopes, is more resistant to various forms of errors prevalent 
//	with MetaTrader.
//			  
//	RETURN VALUE: 
//
//	Ticket number or -1 under some error conditions. 
//
//
//	FEATURES:
//
//		 * Re-trying under some error conditions, sleeping a random 
//		   time defined by an exponential probability distribution.
//
//		 * Automatic normalization of Digits
//
//		 * Automatically makes sure that stop levels are more than
//		   the minimum stop distance, as given by the server. If they
//		   are too close, they are adjusted.
//
//		 * Automatically converts limit orders to market orders 
//		   when the limit orders are rejected by the server for 
//		   being to close to market.
//
//		 * Displays various error messages on the log for debugging.
//
//
//	Matt Kennel, mbkennel@gmail.com  	2006-05-28
//
//=============================================================================
int OrderSendReliable(string symbol, int cmd, double volume, double price,
					  int slippage, double stoploss, double takeprofit,
					  string comment, int magic, datetime expiration = 0, 
					  color arrow_color = CLR_NONE) 
{

	// ------------------------------------------------
	// Check basic conditions see if trade is possible. 
	// ------------------------------------------------
	OrderReliable_Fname = "OrderSendReliable";
	OrderReliablePrint(" attempted " + OrderReliable_CommandString(cmd) + " " + volume + 
						" lots @" + price + " sl:" + stoploss + " tp:" + takeprofit); 
						
	if (!IsConnected()) 
	{
		OrderReliablePrint("error: IsConnected() == false");
		_OR_err = ERR_NO_CONNECTION; 
		return(-1);
	}
	
	if (IsStopped()) 
	{
		OrderReliablePrint("error: IsStopped() == true");
		_OR_err = ERR_COMMON_ERROR; 
		return(-1);
	}
	
	int cnt = 0;
	while(!IsTradeAllowed() && cnt < retry_attempts) 
	{
		OrderReliable_SleepRandomTime(sleep_time, sleep_maximum); 
		cnt++;
	}
	
	if (!IsTradeAllowed()) 
	{
		OrderReliablePrint("error: no operation possible because IsTradeAllowed()==false, even after retries.");
		_OR_err = ERR_TRADE_CONTEXT_BUSY; 

		return(-1);  
	}

	// Normalize all price / stoploss / takeprofit to the proper # of digits.
	int digits = MarketInfo(symbol, MODE_DIGITS);
	if (digits > 0) 
	{
		price = NormalizeDouble(price, digits);
		stoploss = NormalizeDouble(stoploss, digits);
		takeprofit = NormalizeDouble(takeprofit, digits); 
	}
	
	if (stoploss != 0) 
		OrderReliable_EnsureValidStop(symbol, price, stoploss); 

	int err = GetLastError(); // clear the global variable.  
	err = 0; 
	_OR_err = 0; 
	bool exit_loop = false;
	bool limit_to_market = false; 
	
	// limit/stop order. 
	int ticket=-1;

	if ((cmd == OP_BUYSTOP) || (cmd == OP_SELLSTOP) || (cmd == OP_BUYLIMIT) || (cmd == OP_SELLLIMIT)) 
	{
		cnt = 0;
		while (!exit_loop) 
		{
			if (IsTradeAllowed()) 
			{
				ticket = OrderSend(symbol, cmd, volume, price, slippage, stoploss, 
									takeprofit, comment, magic, expiration, arrow_color);
				err = GetLastError();
				_OR_err = err; 
			} 
			else 
			{
				cnt++;
			} 
			
			switch (err) 
			{
				case ERR_NO_ERROR:
					exit_loop = true;
					break;
				
				// retryable errors
				case ERR_SERVER_BUSY:
				case ERR_NO_CONNECTION:
				case ERR_INVALID_PRICE:
				case ERR_OFF_QUOTES:
				case ERR_BROKER_BUSY:
				case ERR_TRADE_CONTEXT_BUSY: 
					cnt++; 
					break;
					
				case ERR_PRICE_CHANGED:
				case ERR_REQUOTE:
					RefreshRates();
					continue;	// we can apparently retry immediately according to MT docs.
					
				case ERR_INVALID_STOPS:
					double servers_min_stop = MarketInfo(symbol, MODE_STOPLEVEL) * MarketInfo(symbol, MODE_POINT); 
					if (cmd == OP_BUYSTOP) 
					{
						// If we are too close to put in a limit/stop order so go to market.
						if (MathAbs(Ask - price) <= servers_min_stop)	
							limit_to_market = true; 
							
					} 
					else if (cmd == OP_SELLSTOP) 
					{
						// If we are too close to put in a limit/stop order so go to market.
						if (MathAbs(Bid - price) <= servers_min_stop)
							limit_to_market = true; 
					}
					exit_loop = true; 
					break; 
					
				default:
					// an apparently serious error.
					exit_loop = true;
					break; 
					
			}  // end switch 

			if (cnt > retry_attempts) 
				exit_loop = true; 
			 	
			if (exit_loop) 
			{
				if (err != ERR_NO_ERROR) 
				{
					OrderReliablePrint("non-retryable error: " + OrderReliableErrTxt(err)); 
				}
				if (cnt > retry_attempts) 
				{
					OrderReliablePrint("retry attempts maxed at " + retry_attempts); 
				}
			}
			 
			if (!exit_loop) 
			{
				OrderReliablePrint("retryable error (" + cnt + "/" + retry_attempts + 
									"): " + OrderReliableErrTxt(err)); 
				OrderReliable_SleepRandomTime(sleep_time, sleep_maximum); 
				RefreshRates(); 
			}
		}
		 
		// We have now exited from loop. 
		if (err == ERR_NO_ERROR) 
		{
			//OrderReliablePrint("apparently successful OP_BUYSTOP or OP_SELLSTOP order placed, details follow.");
			//OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES); 
			//OrderPrint(); 
			return(ticket); // SUCCESS! 
		} 
		if (!limit_to_market) 
		{
			OrderReliablePrint("failed to execute stop or limit order after " + cnt + " retries");
			OrderReliablePrint("failed trade: " + OrderReliable_CommandString(cmd) + " " + symbol + 
								"@" + price + " tp@" + takeprofit + " sl@" + stoploss); 
			OrderReliablePrint("last error: " + OrderReliableErrTxt(err)); 
			return(-1); 
		}
	}  // end	  
  
	if (limit_to_market) 
	{
		OrderReliablePrint("going from limit order to market order because market is too close.");
		if ((cmd == OP_BUYSTOP) || (cmd == OP_BUYLIMIT)) 
		{
			cmd = OP_BUY;
			price = Ask;
		} 
		else if ((cmd == OP_SELLSTOP) || (cmd == OP_SELLLIMIT)) 
		{
			cmd = OP_SELL;
			price = Bid;
		}	
	}
	
	// we now have a market order.
	err = GetLastError(); // so we clear the global variable.  
	err = 0; 
	_OR_err = 0; 
	ticket = -1;

	if ((cmd == OP_BUY) || (cmd == OP_SELL)) 
	{
		cnt = 0;
		while (!exit_loop) 
		{
			if (IsTradeAllowed()) 
			{
				ticket = OrderSend(symbol, cmd, volume, price, slippage, 
									stoploss, takeprofit, comment, magic, 
									expiration, arrow_color);
				err = GetLastError();
				_OR_err = err; 
			} 
			else 
			{
				cnt++;
			} 
			switch (err) 
			{
				case ERR_NO_ERROR:
					exit_loop = true;
					break;
					
				case ERR_SERVER_BUSY:
				case ERR_NO_CONNECTION:
				case ERR_INVALID_PRICE:
				case ERR_OFF_QUOTES:
				case ERR_BROKER_BUSY:
				case ERR_TRADE_CONTEXT_BUSY: 
					cnt++; // a retryable error
					break;
					
				case ERR_PRICE_CHANGED:
				case ERR_REQUOTE:
					RefreshRates();
					continue; // we can apparently retry immediately according to MT docs.
					
				default:
					// an apparently serious, unretryable error.
					exit_loop = true;
					break; 
					
			}  // end switch 

			if (cnt > retry_attempts) 
			 	exit_loop = true; 
			 	
			if (!exit_loop) 
			{
				OrderReliablePrint("retryable error (" + cnt + "/" + 
									retry_attempts + "): " + OrderReliableErrTxt(err)); 
				OrderReliable_SleepRandomTime(sleep_time,sleep_maximum); 
				RefreshRates(); 
			}
			
			if (exit_loop) 
			{
				if (err != ERR_NO_ERROR) 
				{
					OrderReliablePrint("non-retryable error: " + OrderReliableErrTxt(err)); 
				}
				if (cnt > retry_attempts) 
				{
					OrderReliablePrint("retry attempts maxed at " + retry_attempts); 
				}
			}
		}
		
		// we have now exited from loop. 
		if (err == ERR_NO_ERROR) 
		{
			//OrderReliablePrint("apparently successful OP_BUY or OP_SELL order placed, details follow.");
			//OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES); 
			//OrderPrint(); 
			return(ticket); // SUCCESS! 
		} 
		OrderReliablePrint("failed to execute OP_BUY/OP_SELL, after " + cnt + " retries");
		OrderReliablePrint("failed trade: " + OrderReliable_CommandString(cmd) + " " + symbol + 
							"@" + price + " tp@" + takeprofit + " sl@" + stoploss); 
		OrderReliablePrint("last error: " + OrderReliableErrTxt(err)); 
		return(-1); 
	}
}
	

//=============================================================================
//							 OrderCloseReliable()
//
//	This is intended to be a drop-in replacement for OrderClose() which, 
//	one hopes, is more resistant to various forms of errors prevalent 
//	with MetaTrader.
//			  
//	RETURN VALUE: 
//
//		TRUE if successful, FALSE otherwise
//
//
//	FEATURES:
//
//		 * Re-trying under some error conditions, sleeping a random 
//		   time defined by an exponential probability distribution.
//
//		 * Displays various error messages on the log for debugging.
//
//
//	Derk Wehler, ashwoods155@yahoo.com  	2006-07-19
//
//=============================================================================
bool OrderCloseReliable(int ticket, double lots, double price, 
						int slippage, color arrow_color = CLR_NONE) 
{
	OrderReliable_Fname = "OrderCloseReliable";

	OrderReliablePrint(" attempted close of #" + ticket + " price:" + price + 
						" lots:" + lots + " slippage:" + slippage); 

	if (!IsConnected()) 
	{
		OrderReliablePrint("error: IsConnected() == false");
		_OR_err = ERR_NO_CONNECTION; 
		return(false);
	}
	
	if (IsStopped()) 
	{
		OrderReliablePrint("error: IsStopped() == true");
		return(false);
	}
	
	int cnt = 0;
	while(!IsTradeAllowed() && cnt < retry_attempts) 
	{
		OrderReliable_SleepRandomTime(sleep_time,sleep_maximum); 
		cnt++;
	}
	if (!IsTradeAllowed()) 
	{
		OrderReliablePrint("error: no operation possible because IsTradeAllowed()==false, even after retries.");
		_OR_err = ERR_TRADE_CONTEXT_BUSY; 
		return(false);  
	}


	int err = GetLastError(); // so we clear the global variable.  
	err = 0; 
	_OR_err = 0; 
	bool exit_loop = false;
	cnt = 0;
	bool result = false;
	
	while (!exit_loop) 
	{
		if (IsTradeAllowed()) 
		{
			result = OrderClose(ticket, lots, price, slippage, arrow_color);
			err = GetLastError();
			_OR_err = err; 
		} 
		else 
			cnt++;

		if (result == true) 
			exit_loop = true;

		switch (err) 
		{
			case ERR_NO_ERROR:
				exit_loop = true;
				break;
				
			case ERR_SERVER_BUSY:
			case ERR_NO_CONNECTION:
			case ERR_INVALID_PRICE:
			case ERR_OFF_QUOTES:
			case ERR_BROKER_BUSY:
			case ERR_TRADE_CONTEXT_BUSY: 
			case ERR_TRADE_TIMEOUT:		// for modify this is a retryable error, I hope. 
				cnt++; 	// a retryable error
				break;
				
			case ERR_PRICE_CHANGED:
			case ERR_REQUOTE:
				RefreshRates();
				continue; 	// we can apparently retry immediately according to MT docs.
				
			default:
				// an apparently serious, unretryable error.
				exit_loop = true;
				break; 
				
		}  // end switch 

		if (cnt > retry_attempts) 
			exit_loop = true; 
			
		if (!exit_loop) 
		{
			OrderReliablePrint("retryable error (" + cnt + "/" + retry_attempts + 
								"): "  +  OrderReliableErrTxt(err)); 
			OrderReliable_SleepRandomTime(sleep_time,sleep_maximum); 
			RefreshRates(); 
		}
		
		if (exit_loop) 
		{
			if ((err != ERR_NO_ERROR) && (err != ERR_NO_RESULT)) 
				OrderReliablePrint("non-retryable error: "  + OrderReliableErrTxt(err)); 

			if (cnt > retry_attempts) 
				OrderReliablePrint("retry attempts maxed at " + retry_attempts); 
		}
	}  
	
	// we have now exited from loop. 
	if ((result == true) || (err == ERR_NO_ERROR)) 
	{
		//OrderReliablePrint("apparently successful modification order, updated trade details follow.");
		//OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES); 
		//OrderPrint(); 
		return(true); // SUCCESS! 
	} 
	
	OrderReliablePrint("failed to execute close after " + cnt + " retries");
	OrderReliablePrint("failed close: Ticket #" + ticket + ", Price: " + 
						price + ", Slippage: " + slippage); 
	OrderReliablePrint("last error: " + OrderReliableErrTxt(err)); 
	
	return(false);  
}
 
 

//=============================================================================
//=============================================================================
//								Utility Functions
//=============================================================================
//=============================================================================
//}

string OrderReliableErrTxt(int err) 
{
	return ("" + err + ":" + ErrorDescription(err)); 
}


void OrderReliablePrint(string s) 
{
	// Print to log prepended with stuff;
	//Print(OrderReliable_Fname + " " + OrderReliableVersion + ":" + s);
	Print(s);
}


string OrderReliable_CommandString(int cmd) 
{
	if (cmd == OP_BUY) 
		return("OP_BUY");

	if (cmd == OP_SELL) 
		return("OP_SELL");

	if (cmd == OP_BUYSTOP) 
		return("OP_BUYSTOP");

	if (cmd == OP_SELLSTOP) 
		return("OP_SELLSTOP");

	if (cmd == OP_BUYLIMIT) 
		return("OP_BUYLIMIT");

	if (cmd == OP_SELLLIMIT) 
		return("OP_SELLLIMIT");

	return("(CMD==" + cmd + ")"); 
}


//=============================================================================
//
//						 OrderReliable_EnsureValidStop()
//
// 	Adjust stop loss so that it is legal.
//
//	Matt Kennel mbkennel@gmail.com.
//
//=============================================================================
void OrderReliable_EnsureValidStop(string symbol, double price, double& sl) 
{
	// Return if no S/L
	if (sl == 0) 
		return;
	
	double servers_min_stop = MarketInfo(symbol, MODE_STOPLEVEL) * MarketInfo(symbol, MODE_POINT); 
	
	if (MathAbs(price - sl) <= servers_min_stop) 
	{
		// we have to adjust the stop.
		if (price > sl)
			sl = price - servers_min_stop;	// we are long
			
		else if (price < sl)
			sl = price + servers_min_stop;	// we are short
			
		else
			OrderReliablePrint("EnsureValidStop: error, passed in price == sl, cannot adjust"); 
			
		sl = NormalizeDouble(sl, MarketInfo(symbol, MODE_DIGITS)); 
	}
}


//=============================================================================
//
//						 OrderReliable_SleepRandomTime()
//
//	This sleeps a random amount of time defined by an exponential 
//	probability distribution. The mean time, in Seconds is given 
//	in 'mean_time'.
//
//	This is the back-off strategy used by Ethernet.  This will 
//	quantize in tenths of seconds, so don't call this with a too 
//	small a number.  This returns immediately if we are backtesting
//	and does not sleep.
//
//	Matt Kennel mbkennel@gmail.com.
//
//=============================================================================
void OrderReliable_SleepRandomTime(double mean_time, double max_time) 
{
	if (IsTesting()) 
		return; 	// return immediately if backtesting.

	double tenths = MathCeil(mean_time / 0.1);
	if (tenths <= 0) 
		return; 
	 
	int maxtenths = MathRound(max_time/0.1); 
	double p = 1.0 - 1.0 / tenths; 
	  
	Sleep(1000); 	// one tenth of a second
	
	for(int i=0; i < maxtenths; i++)  
	{
		if (MathRand() > p*32768) 
			break; 
			
		// MathRand() returns in 0..32767
		Sleep(1000); 
	}
}  




